VERSION 5.00
Begin VB.Form frmFindWhat 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "String to search"
   ClientHeight    =   1935
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4320
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1935
   ScaleWidth      =   4320
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkEnableReplace 
      Caption         =   "Enable Replace"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   1560
      Width           =   1455
   End
   Begin VB.TextBox txtToReplace 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   4095
   End
   Begin VB.CheckBox chkCaseSensitive 
      Caption         =   "Case Sensitive"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1200
      Value           =   1  'Checked
      Width           =   1455
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   495
      Left            =   3120
      TabIndex        =   5
      Top             =   1320
      Width           =   1095
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   495
      Left            =   1800
      TabIndex        =   4
      Top             =   1320
      Width           =   1095
   End
   Begin VB.TextBox txtToFind 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   4095
   End
   Begin VB.Label Label1 
      Caption         =   "Replace:"
      Height          =   195
      Left            =   120
      TabIndex        =   7
      Top             =   600
      Width           =   645
   End
   Begin VB.Label lblSearch 
      Caption         =   "Search:"
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   0
      Width           =   555
   End
End
Attribute VB_Name = "frmFindWhat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private stringToSearch As String
Private stringToReplace As String
Private caseSensitive As Boolean
Private replaceEnabled As Boolean


Private Sub chkEnableReplace_Click()
    If chkEnableReplace.Value = vbChecked Then
        txtToReplace.Locked = False
        txtToReplace.BackColor = COLOR_FONDOVENTANA
    Else
        txtToReplace.Locked = True
        txtToReplace.BackColor = COLOR_AMARILLO
    End If

End Sub

Private Sub cmdCancel_Click()
    txtToFind.Text = vbNullString
    cmdOK_Click
End Sub
Private Sub cmdOK_Click()
    stringToSearch = txtToFind.Text
    stringToReplace = txtToReplace.Text
    caseSensitive = (chkCaseSensitive.Value = vbChecked)
    replaceEnabled = (chkEnableReplace.Value = vbChecked)
    Unload Me
End Sub
Private Sub Form_Load()
    txtToFind.Text = stringToSearch
    txtToFind.SelStart = 0
    txtToFind.SelLength = Len(stringToSearch)
    txtToReplace.Text = stringToReplace
End Sub

Public Function Ask(sProposed As String, sReplace As String, bCaseSensitive As Boolean, readOnly As Boolean) As String

    If readOnly Then
        chkEnableReplace.Value = Unchecked
        chkEnableReplace.enabled = False
        sReplace = vbNullString
    End If
    
    chkEnableReplace_Click
    
    stringToSearch = sProposed
    stringToReplace = sReplace
    chkCaseSensitive.Value = IIf(bCaseSensitive, vbChecked, vbUnchecked)
    Form_Load
   
    frmLib_LinkInstance.Stopped
    frmFindWhat.Show vbModal
    frmLib_LinkInstance.Running
    
    'Si no se desea reemplazar, se sustituye por null
    If replaceEnabled = False Then
        sReplace = vbNullChar
    Else
        sReplace = stringToReplace
    End If
    
    bCaseSensitive = caseSensitive
    Ask = stringToSearch
    Unload Me
End Function


