VERSION 5.00
Begin VB.Form frmRepositorio 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Repository"
   ClientHeight    =   885
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8385
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   885
   ScaleWidth      =   8385
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCopy 
      Caption         =   "Copy"
      Height          =   350
      Left            =   2200
      TabIndex        =   2
      Top             =   480
      Width           =   1935
   End
   Begin VB.CommandButton cmdSeekAllFsm 
      Caption         =   "Seek in all FSM"
      Height          =   350
      Left            =   4280
      TabIndex        =   3
      Top             =   480
      Width           =   1935
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   350
      Left            =   6360
      TabIndex        =   4
      Top             =   480
      Width           =   1935
   End
   Begin VB.CommandButton cmdInsert 
      Caption         =   "Insert"
      Default         =   -1  'True
      Height          =   350
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   1935
   End
   Begin VB.ComboBox cmbReposi 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      ItemData        =   "Repositorio.frx":0000
      Left            =   60
      List            =   "Repositorio.frx":0002
      Sorted          =   -1  'True
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   30
      Width           =   8295
   End
End
Attribute VB_Name = "frmRepositorio"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private nombres() As String
Private indNombres As Long
Private nombre As String
Private Enum enumTipoNodo
    SALIR
    INSERTAR
    COPIAR
End Enum
Private action As enumTipoNodo

Public Sub Edita(cMax As CodeMax, Optional txt As TextBox = Nothing, Optional frmDeep As Integer = 0)
Dim o As Object
Dim enabled  As Boolean
Dim grafo As AddFlow

    If Not (cMax Is Nothing) Then
        Set o = cMax
        enabled = Not o.readOnly
    ElseIf Not (txt Is Nothing) Then
        Set o = txt
        enabled = Not o.Locked
    End If
    
    If enabled Then
        indNombres = 0
            
        Set grafo = mainFrm.ActiveForm.AddFlow1
        'Captura textos del fsm actual
        SeekNames GetFsmTexts(grafo)
        If indNombres > 0 Then
            ShowNames
            With o
                Select Case frmDeep
                    Case 1
                        frmRepositorio.Left = .Container.Left
                        frmRepositorio.top = .Container.top
                    Case 2
                        frmRepositorio.Left = .Container.Container.Left
                        frmRepositorio.top = .Container.Container.top
                    Case Else
                        frmRepositorio.Left = .Left
                        frmRepositorio.top = .top
                End Select
                frmLib_LinkInstance.Stopped
                frmRepositorio.Show vbModal
                frmLib_LinkInstance.Running
            
                Select Case action
                    Case INSERTAR
                        .SelText = nombre
                        Clipboard.SetText nombre
                    Case COPIAR
                        Clipboard.SetText nombre
                    Case SALIR
                End Select
            End With
        End If
    End If
    Unload Me
End Sub

Private Sub cmdSeekAllFsm_Click()
Dim i As Integer
Dim s As String
    For i = 1 To Forms.count - 1
        If Forms(i).Tag = FILE_FSM_EXT Then 'Comprueba Marca de Form vlido
            s = s & GetFsmTexts(Forms(i).AddFlow1)
        End If
    Next
    SeekNames s
    ShowNames
End Sub

Private Sub cmdInsert_Click()
    nombre = cmbReposi.Text
    action = INSERTAR
    Unload Me
End Sub
Private Sub cmdCopy_Click()
    nombre = cmbReposi.Text
    action = COPIAR
    Unload Me
End Sub
Private Sub cmdCancel_Click()
    action = SALIR
    Unload Me
End Sub
Private Function GetFsmTexts(grafo As AddFlow) As String
Dim nodo As afNode
Dim s As String
    'Busca nombres en nodos
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
            s = s & DimeDatoEstado(ACTIONS_ENTRY, nodo) & vbNewLine & _
                    DimeDatoEstado(ACTIONS_MOORE, nodo) & vbNewLine & _
                    DimeDatoEstado(ACTIONS_ELSE, nodo) & vbNewLine & _
                    DimeDatoEstado(ACTIONS_EXIT, nodo) & vbNewLine
        ElseIf EsTransicion(nodo) Then
            s = s & DimeDatoTrans(CONDITIONS, nodo) & vbNewLine & _
                    DimeDatoTrans(ACTIONS_MEALY, nodo) & vbNewLine
        End If
    Next
    'Busca nombres en grafo
    s = s & DimeDatoFSM(FSM_NAME, grafo) & vbNewLine & _
            DimeDatoFSM(FSM_PARAMETER, grafo) & vbNewLine & _
            DimeDatoFSM(FSM_RETURN_TYPE, grafo) & vbNewLine & _
            DimeDatoFSM(FSM_MOD_HEADER, grafo) & vbNewLine & _
            DimeDatoFSM(FSM_FUN_HEADER, grafo) & vbNewLine & _
            DimeDatoFSM(FSM_GLOBAL_INIT, grafo) & vbNewLine & _
            DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, grafo) & vbNewLine & _
            DimeDatoFSM(FSM_GLOBAL_POS_ACCION, grafo) & vbNewLine & _
            DimeDatoFSM(FSM_GLOBAL_END, grafo) & vbNewLine
            
    GetFsmTexts = s
End Function

Private Sub SeekNames(sSource As String)
Dim i As Long
Dim c As String
Dim sNombre As String
Dim bCargandoItem As Boolean
Dim bItemFuncion As Boolean
    
    'Filtra solo los item 'vlidos'
    bCargandoItem = False
    bItemFuncion = False
    sSource = sSource + " "
    For i = 1 To Len(sSource)
        'Lee el siguiente char
        c = Mid$(sSource, i, 1)

        'Distingue si esta leyendo o no un posible item
        If bCargandoItem Then
            
            'Procesado especial de las funciones
            If bItemFuncion Then
                bItemFuncion = False
                If c = ")" Then 'Si no tiene parmetros cierra el parntesis
                    sNombre = sNombre + "()"
                Else            'Si tiene parmetros deja abierto el parntesis
                    sNombre = sNombre + "("
                    c = vbCr
                    i = i - 1
                End If
            End If
            
            'Espera hasta encontrar el prximo fin de item
            Select Case c
                Case " ", vbCr, "=", "<", ">", "+", "-", "*", "/", ")", ",", ";", ":"
                    bCargandoItem = False
                    If Len(sNombre) > 1 Then
                        'Anula el dato si contiene algn carcter no vlido
                        If ValidString(sNombre) Then AppendName sNombre
                    End If
                    sNombre = vbNullString
                Case "("
                    bItemFuncion = True
                Case Else
                'Aade un carcter
                sNombre = sNombre + c
            End Select
        Else
            'Espera hasta encontrar el prximo comienzo de item
            If ("A" <= c And c <= "Z") Or ("a" <= c And c <= "z") Or c = Chr$(34) Or c = "#" Then
                bCargandoItem = True
                sNombre = c
            End If
        End If
    Next
End Sub
'Carge el Combo con todos los nombres
Private Sub ShowNames()
Dim i As Long
    'Vaca ComboBox
    cmbReposi.Clear
    'Carga ComboBox
    If indNombres Then
        For i = 1 To indNombres
            cmbReposi.AddItem nombres(i)
        Next
        cmbReposi.ListIndex = 0
    End If
End Sub

Private Sub AppendName(newName As String)
Dim i As Long

    'Comprueba si es un nuevo item
    For i = 1 To indNombres
        If newName = nombres(i) Then Exit Sub
    Next
    
    If i <= REPOSITORY_MAX_ITEMS Then
        indNombres = i
        ReDim Preserve nombres(1 To indNombres) As String
        nombres(indNombres) = newName
    End If
End Sub

