Attribute VB_Name = "modMain"
Option Explicit

Public mainFrm As frmMain
Private aceptaPegar As Boolean
Public lineaCommando As String
Public soloModoCommand  As Boolean
Private soloList  As Boolean
Private soloC As Boolean
Private soloC_SwCase As Boolean
Private soloC_DirectP As Boolean
Private soloC_PArray As Boolean
Private soloC_HSwCase As Boolean
Private soloC_HSwCaseReentrant As Boolean
Private soloHTML As Boolean
Private soloHTML_FLAT As Boolean
Private soloWMF As Boolean
Public sinDebugInfo As Boolean
Public conDebugInfo As Boolean
Public sinAnsiComments As Boolean
Public conAnsiComments As Boolean
Public bSinTextBoxesInCode As Boolean
Public bConTextBoxesInCode As Boolean
Public bSinBitFields As Boolean
Public bConBitFields As Boolean
Private pathOUT As String
Public captionDelPrograma As String
Public abrirInmediatamenteFile As String
Public findCaseSensitive As Boolean
Public prIns As New clsLib_PrevInstance
Public cMax As clsLib_OptCMax

'Public defaultFillColor As Long
'Public defaultForeColor As Long

Private Sub Main()
Dim pathError As Boolean
Dim s As String
Dim activeFrmDoc As frmDoc

SEPARADOR = Chr$(183) & Chr$(32) & Chr$(183) '" "   note:  must be:  chr$(183) else the Japanish PC don't work

#If LEAR_MODE Then
    captionDelPrograma = "FSM Editor v" & App.Major & "." & App.Minor & "r" & App.Revision
#Else
    captionDelPrograma = "HFSM Editor v" & App.Major & "." & App.Minor & "r" & App.Revision
#End If
'    defaultFillColor = COLOR_FILL_DEFAULT
'    defaultForeColor = COLOR_FORE_DEFAULT
    
    
    'Comprobacin inicial de la linea de comando
    lineaCommando = RemoveQuotationMarks(Command())
    If LenB(lineaCommando) > 0 Then
        If SeElimino(lineaCommando, "/?") Then
        MsgBox App.EXEName & " file.fsm [/?][/C[H]][/H[L]][/W][/O<path>][/E<path>][/D+|-][/AC+|-][/PT+|-][/BF+|-]" & vbNewLine & _
               " /C   generates default C-code" & vbNewLine & _
               " /CH  generates ""hierachical switch case"" code" & vbNewLine & _
               " /CHR generates ""hierachical switch case reentrant"" code" & vbNewLine & _
               " /LS  generates list" & vbNewLine & _
               " /H   generates HTML" & vbNewLine & _
               " /HL  generates HTML with" & vbNewLine & _
               "         links in the same path" & vbNewLine & _
               " /W   generates WMF" & vbNewLine & _
               " /O   output path" & vbNewLine & _
               " /E   error file output path" & vbNewLine & _
               " /D+  with debug info" & vbNewLine & " /D-   without debug info" & vbNewLine & _
               " /AC+ ANSI comments: ""/* */""" & vbNewLine & " /AC- not ANSI comments: ""//  """ & vbNewLine & _
               " /PT+ print the text boxes into the code" & vbNewLine & " /PT- don't print the text boxes into the code" & vbNewLine & _
               " /BF- don't use bitfields" & vbNewLine & " /BF+ use bitfields to save RAM" & vbNewLine & _
               " /?   Help" & vbNewLine, _
               vbInformation, _
               "Command line help"
            End
        End If
        pathError = EliminarPath(lineaCommando, "/E*", pathErrOUT)
        pathError = pathError Or EliminarPath(lineaCommando, "/O*", pathOUT)

        soloC_SwCase = SeElimino(lineaCommando, "/CS")
        soloC_DirectP = SeElimino(lineaCommando, "/CP")
        soloC_PArray = SeElimino(lineaCommando, "/CA")
        soloC_HSwCaseReentrant = SeElimino(lineaCommando, "/CHR")
        soloC_HSwCase = SeElimino(lineaCommando, "/CH")
        soloC = SeElimino(lineaCommando, "/C")
        soloList = SeElimino(lineaCommando, "/LS")
        soloHTML_FLAT = SeElimino(lineaCommando, "/HL")
        soloHTML = SeElimino(lineaCommando, "/H")
        soloWMF = SeElimino(lineaCommando, "/W")
        sinDebugInfo = SeElimino(lineaCommando, "/D-")
        conDebugInfo = SeElimino(lineaCommando, "/D+") And (sinDebugInfo = False)
        sinAnsiComments = SeElimino(lineaCommando, "/AC-")
        conAnsiComments = SeElimino(lineaCommando, "/AC+") And (sinAnsiComments = False)
        bSinTextBoxesInCode = SeElimino(lineaCommando, "/PT-")
        bConTextBoxesInCode = SeElimino(lineaCommando, "/PT+") And (bSinTextBoxesInCode = False)
        bSinBitFields = SeElimino(lineaCommando, "/BF-")
        bConBitFields = SeElimino(lineaCommando, "/BF+") And (bSinBitFields = False)
        
        'Disjuncion
        soloModoCommand = soloC Or _
                          soloHTML Or _
                          soloHTML_FLAT Or _
                          soloWMF Or _
                          soloC_SwCase Or _
                          soloC_DirectP Or _
                          soloC_PArray Or _
                          soloC_HSwCase Or _
                          soloC_HSwCaseReentrant Or _
                          soloList
        
        If soloC_SwCase Or soloC_DirectP Or soloC_PArray Then
            LogError "The options /CS, /CP & /CA aren not valid for this release"
            lineaCommando = vbNullString
        End If
                          
                          
        If Not IsThisAValidFile(lineaCommando) Then
            LogError "Fsm path error [" & lineaCommando & "]"
            lineaCommando = vbNullString
        End If
        If pathError Then lineaCommando = vbNullString
    End If

    If soloModoCommand Then
        #If DEBUG_ExtendLogOut Then
            Logout " . . . . . . . . . . . . . . ."
            If soloC Then Logout " Main, Solo compilar (Default)"
            If soloC_SwCase Then Logout " Main, Solo compilar (Switch Case)"
            If soloC_HSwCase Then Logout " Main, Solo compilar (Hierarchical Switch Case)"
            If soloC_HSwCaseReentrant Then Logout " Main, Solo compilar (Hierarchical Switch Case Reentrant)"
            If soloC_DirectP Then Logout " Main, Solo compilar (Direct Pointer)"
            If soloC_PArray Then Logout " Main, Solo compilar (Pointer Array)"
            If soloHTML Then Logout " Main, Solo generar html"
            If soloHTML_FLAT Then Logout " Main, Solo generar html con links en mismo directorio"
            If soloWMF Then Logout " Main, Solo generar WMF"
        #End If
        If LenB(lineaCommando) > 0 Then
            s = lineaCommando
            Set mainFrm = New frmMain
            mainFrm.Show
            
            Set activeFrmDoc = mainFrm.ActiveForm
            If LenB(activeFrmDoc.Caption) > 0 Then
                If soloC_SwCase Then
'                    activeFrmDoc.mnuGenerate_C_code_SwitchCase_Click
                ElseIf soloC_DirectP Then
'                    activeFrmDoc.mnuGenerate_C_code_Pointers_Click
                ElseIf soloC_PArray Then
'                    activeFrmDoc.mnuGenerate_C_code_TablaPoint_Click
                ElseIf soloC_HSwCase Then
                    activeFrmDoc.mnuGenerate_C_code_Hierarchical_Click
                ElseIf soloC_HSwCaseReentrant Then
                    activeFrmDoc.mnuGenerate_C_code_HierarchicalReentrant_Click
                ElseIf soloC Then
                    activeFrmDoc.mnuGenerate_C_code_Default
                End If
                If soloHTML Or soloHTML_FLAT Then
                    FileSaveAsHTML activeFrmDoc
                ElseIf soloWMF Then
                    FileSaveAsEMF activeFrmDoc
                End If
                
                If soloList Then
                    GenerarListado activeFrmDoc
                End If
            Else
                LogError "Fsm error loading:[" & s & "]"
            End If

        End If
        #If DEBUG_ExtendLogOut Then
            Logout " Main, End"
        #End If
        End
    ElseIf App.PrevInstance Then
        #If DEBUG_ExtendLogOut Then
            Logout " - - - - - - - - - - - - - - -"
            Logout " Main, arranca una nueva instancia"
        #End If
        If LenB(lineaCommando) > 0 Then
            prIns.ProcessNewInstances lineaCommando
        End If
        End
    Else
        BorraLogout
        
        #If LEAR_MODE Then
            App.HelpFile = App.Path & "\L_fsm.hlp"
        #Else
            App.HelpFile = App.Path & "\H_fsm.hlp"
        #End If

        #If DEBUG_ExtendLogOut Then
            Logout "+ + + + + + + + + + + + + + +"
            Logout "Main, Arranca la aplicacin"
        #End If
        Set cMax = New clsLib_OptCMax
        Set mainFrm = New frmMain

        #If DEBUG_ExtendLogOut Then
            Logout "Main, mainFrm.Show"
        #End If
        mainFrm.Show

        'Load Daemon to catch all secondary instances
        #If DEBUG_ExtendLogOut Then
            Logout "Main, frmLib_LinkInstance"
        #End If
        Load frmLib_LinkInstance
    End If
    
    #If DEBUG_ExtendLogOut Then
        Logout "Main, end"
    #End If
End Sub

Public Function IsThisAValidFile(file As String) As Boolean
    IsThisAValidFile = ((UCase$(Right$(file, Len(FILE_FSM_EXT) + 1)) = ("." & FILE_FSM_EXT)) And FileExist(file))
End Function

Public Sub LoadNewDoc(nombrar As Boolean)
    Static lDocumentCount As Long
    Dim frmD As frmDoc
    Set frmD = New frmDoc
    frmD.nuevoFSM = nombrar
    If nombrar Then
        lDocumentCount = lDocumentCount + 1
        frmD.Caption = DEF_DOC_NAME & Right$("000" & Format$(lDocumentCount), 4)
        frmD.sFullDocname = FileConRuta(frmD.Caption & "." & LCase$(FILE_FSM_EXT))
        'frmD.bHistoryFsm = True
        frmD.undRed.Init frmD
    End If
    frmD.Show
End Sub

' Display file open dialog and select a file
Private Function GetFileName(myext As String, myfilter As String, hideReadOnly As Boolean) As String
    With mainFrm.dlgCommonDialog
        .CancelError = False
        .DefaultExt = myext
        .Filter = myfilter
        .fileName = vbNullString
        .Flags = cdlOFNOverwritePrompt Or cdlOFNCreatePrompt
        If hideReadOnly Then
            .Flags = .Flags Or cdlOFNHideReadOnly
        Else
            .Flags = .Flags Or cdlOFNReadOnly
        End If
        .ShowOpen
        hideReadOnly = (.Flags And cdlOFNReadOnly) = cdlOFNReadOnly
        GetFileName = .fileName
    End With
End Function

Public Function FileOpen(sFilename As String) As Boolean
Dim sFile As String
Dim soloLectura As Boolean
Dim i As Integer
Dim sFirma As String
Dim seguir As Long
Dim activeFrmDoc As frmDoc

    soloLectura = False
    If LenB(sFilename) = 0 Then
        sFile = GetFileName(FILE_FSM_EXT, FILE_FSM_FLT, soloLectura)
        If LenB(sFile) = 0 Then Exit Function
    Else
        sFile = sFilename
        soloLectura = True
    End If

    'Comprueba si ya esta abierto el fichero
    For i = 1 To Forms.count - 1
        If Forms(i).Tag = FILE_FSM_EXT Then 'Comprueba Marca de Form vlido
            If LCase$(Forms(i).sFullDocname) = LCase$(sFile) Then
                Forms(i).SetFocus
                Exit Function
            End If
        Else
            If Forms(i).Tag <> READY_TO_RECEIVE Then   'Comprueba Marca de Form vlido
                Logout " FileOpen, Forms(i).Tag <> FILE_FSM_EXT? "
            End If
        End If
    Next
    
    If Len(sFile) > 0 Then
        If FileExist(sFile, vbNormal + vbReadOnly) Then
            LoadNewDoc False
            
            Set activeFrmDoc = mainFrm.ActiveForm
            With activeFrmDoc
                On Error GoTo ControlError   ' Activa la rutina de control de errores.
                .AddFlow1.LoadFile sFile
                On Error GoTo 0   ' Desactiva la deteccin de errores.
                .sFullDocname = sFile
                
                ' Lee la informacion del grafo
                DameGrafoInfo .AddFlow1
                .GetGrafoConfig
                CargaTextoNodos .AddFlow1
                
                .undRed.Init activeFrmDoc   'Must be after GetGrafoConfig

                sFirma = DimeDatoFSM(FSM_FIRMA, .AddFlow1)
                If sFirma > FIRMA_VALIDA Then
                    seguir = MsgBox("Atention this FSM has newer signature." & vbNewLine & _
                                    " Ignore and continue?", vbYesNo Or vbDefaultButton2 Or vbCritical, _
                                    "The file signature don't match: [" & sFirma & "]")
                    If seguir = vbNo Then
                        .undRed.ClearGraphChanges
                        Unload activeFrmDoc
                        Exit Function
                    End If
                End If
                .Caption = FileSinRutaNiExtension(sFile)
                .AddFlow1.readOnly = soloLectura
                .AddFlow1.Refresh 'Always after readOnly changes
                .RefreshButtons
                .undRed.ClearGraphChanges
            End With
        End If
    End If
Exit Function ' Salir para evitar el controlador.
Dim iReintentos As Long
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case &HF108&          'No es un fichero FSM
            iReintentos = iReintentos + 1
            If iReintentos < 200 Then
                If iReintentos = 1 Then Logout " FileOpen, .AddFlow1.LoadFile " & sFile
                Logout "  reintento" & Str$(iReintentos)
                DoEvents
                Resume ' Continuar ejecucin en la lnea que caus el error.
            Else
                Logout " FileOpen, Error #" & Str$(Err.Number) & ": no es un fichero FSM"
'                Error Err.Number
            End If
            Exit Function
        Case 438
            iReintentos = iReintentos + 1
            If iReintentos < 200 Then
                If iReintentos = 1 Then Logout " FileOpen, Error #" & Str$(Err.Number) & ": " & Err.Description
                Logout "  reintento" & Str$(iReintentos)
                DoEvents
                Resume ' Continuar ejecucin en la lnea que caus el error.
            Else
                Logout " FileOpen, Error #" & Str$(Err.Number) & ": " & Err.Description
'                Error Err.Number
            End If
            Exit Function
        Case Else
            Logout " FileOpen, Error #" & Str$(Err.Number) & ": " & Err.Description
            Error Err.Number
    End Select
    Resume Next  ' Continuar ejecucin en la lnea siguiente a la que caus el error.
End Function
Public Sub FilePrint(frm As frmDoc)
    On Error Resume Next

    With mainFrm.PrnFlow1
        .hWndFlow = frm.AddFlow1.hwnd
        .PrinterSettings = True
        .DocName = frm.Caption
        .Header = frm.Caption & "||" & Format$(Date, "dd-mmm-yyyy")
        .Preview = False
        .PrintDoc
    End With
'    With mainFrm.dlgCommonDialog
'        .CancelError = True
'        .Flags = cdlPDReturnDC Or cdlPDNoPageNums
'        .Flags = .Flags Or cdlPDAllPages
'        .ShowPrinter
'    End With
'    If Err <> MSComDlg.cdlCancel Then
'        With mainFrm.VSPrinter1
'            .Preview = False
'            .ShowGuides = True
'            .StartDoc
'            .RenderControl = frm.AddFlow1.hwnd
'            .EndDoc
'        End With
'    End If
End Sub

Public Sub FilePrintPreview(frm As frmDoc)
    On Error Resume Next
    
    mainFrm.picPrint.Visible = Not mainFrm.picPrint.Visible
    frm.mnuFilePrintPreview.Checked = mainFrm.picPrint.Visible
    mainFrm.tbToolBar.Buttons("Preview").Value = IIf(mainFrm.picPrint.Visible, tbrPressed, tbrUnpressed)


    If mainFrm.picPrint.Visible Then
        With mainFrm.PrnFlow1
            .hWndFlow = frm.AddFlow1.hwnd
            .Preview = True
            .PageBorder = PageBorderDottedBoxDot
            .DocName = frm.Caption
            .Footer = "|- Page <PAGE> -|"
            .Header = frm.Caption & "||" & Format$(Date, "dd-mmm-yyyy")
            .PrintDoc
        End With
    End If
'   ' VSVIEW settings
'    With mainFrm.VSPrinter1
'        .Visible = Not .Visible
'        frm.mnuFilePrintPreview.Checked = .Visible
'        If .Visible Then
'            .Preview = True
'            .ShowGuides = True
'            .StartDoc
'            .RenderControl = frm.AddFlow1.hwnd
'            .EndDoc
'        End If
'    End With
End Sub

Public Sub FilePrinterSetup()
'    ShowPageSetup
    On Error Resume Next
    With mainFrm.dlgCommonDialog
        .CancelError = True
        .ShowPrinter
    End With
' VSVIEW settings
'
'    mainFrm.VSPrinter1.action = paPageSetup
'    'mainFrm.VSPrinter1.PrintDialog pdPageSetup
'    'mainFrm.VSPrinter1.PrintDialog pdPrinterSetup
'    'mainFrm.VSPrinter1.Action = paChoosePrinter
'    'mainFrm.VSPrinter1.Action = paChoosePrintFile
End Sub

Public Sub EditDelete(frm As frmDoc)
    EliminaSeleccion frm.AddFlow1
End Sub

Public Sub EditCut(frm As frmDoc)
    With frm
        If .Text1.Visible Then
            Clipboard.Clear
            Clipboard.SetText .Text1.SelText, vbCFText
            .Text1.SelText = vbNullString
        Else
            EditCopy frm
            If aceptaPegar Then
                EditDelete frm
            End If
        End If
    End With
End Sub

Public Sub EditCopy(frm As frmDoc)
    With frm
        If .Text1.Visible Then
            Clipboard.Clear
            Clipboard.SetText .Text1.SelText, vbCFText
        Else
            ' Copy to clipboard using the "AddFlow Stream" format
            .AddFlow1.Copy afSelectedItems
            aceptaPegar = EsAceptable_CopiarPegar(.AddFlow1)
            ' Copy to clipboard using the "enhanced metafile" format
            Clipboard.SetData .AddFlow1.ExportPicture(afSelectedItems, False, True)
        End If
    End With
End Sub

Public Sub EditPaste(frm As frmDoc)
    With frm
        If .Text1.Visible Then
            .Text1.SelText = Clipboard.GetText(vbCFText)
        Else
            If .AddFlow1.CanPaste() And aceptaPegar Then
                .AddFlow1.Paste True
            End If
        End If
    End With
End Sub

Public Sub FileSaveAll(frm As frmDoc)
Dim i As Long
    For i = Forms.count - 1 To 1 Step -1
        If Forms(i).Tag = FILE_FSM_EXT Then 'Comprueba Marca de Form vlido
            'Forms(i).SetFocus
            FileSave Forms(i)
        Else
            If Forms(i).Tag <> READY_TO_RECEIVE Then   'Comprueba Marca de Form vlido
                Logout " mnuFileSaveAll_Click, Forms(i).Tag <> FILE_FSM_EXT? "
            End If
        End If
    Next
    frm.SetFocus
End Sub

Public Sub FileSave(frm As frmDoc)
    If frm.undRed.GraphHasChanged() Then
        frm.SetFocus  'Changing the .ActiveForm to me
        If frm.nuevoFSM Then
            FileSaveAs frm
        Else
            SalvaDiagrama frm
        End If
    End If
End Sub

Public Sub FileSaveAs(frm As frmDoc)
    With mainFrm.dlgCommonDialog
        .Filter = FILE_FSM_FLT
        .DefaultExt = FILE_FSM_EXT
        .Flags = cdlOFNOverwritePrompt Or cdlOFNCreatePrompt Or cdlOFNHideReadOnly
        .fileName = frm.sFullDocname
        .CancelError = True
       
        On Error GoTo ControlError   ' Activa la rutina de control de errores.
        .ShowSave
        On Error GoTo 0   ' Desactiva la deteccin de errores.
        
        If LenB(.fileName) > 0 Then
            frm.sLastFullDocname = frm.sFullDocname
            frm.sFullDocname = .fileName
            frm.Caption = FileSinRutaNiExtension(.fileName)
            SalvaDiagrama frm
        End If
    End With
Exit Sub   ' Salir para evitar el controlador.
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case cdlCancel   'se Cancelo la orden
            mainFrm.dlgCommonDialog.fileName = vbNullString
        Case Else
            Logout " FileSaveAs, Error #" & Str$(Err.Number) & ": " & Err.Description
            Error Err.Number
    End Select
    Resume Next  ' Continuar ejecucin en la lnea siguiente a la que caus el error.
End Sub

Public Sub FileSaveAsEMF(frm As frmDoc)
    With mainFrm.dlgCommonDialog
        .DefaultExt = FILE_EMF_EXT
        .Filter = FILE_EMF_FLT
        If LenB(pathOUT) = 0 Then
            .fileName = FileSinExtension(frm.sFullDocname)
        Else
            .fileName = pathOUT & "\" & FileSinRutaNiExtension(frm.sFullDocname)
        End If
        If LenB(.fileName) > 0 Then .fileName = .fileName & "." & LCase$(FILE_EMF_EXT)
        .DialogTitle = "Save As Enhanced Metafile..."
        .Flags = cdlOFNOverwritePrompt Or cdlOFNCreatePrompt Or cdlOFNHideReadOnly
        .CancelError = True
        If Not soloWMF Then
            On Error GoTo ControlError   ' Activa la rutina de control de errores.
            .ShowSave
            On Error GoTo 0   ' Desactiva la deteccin de errores.
        End If
        If LenB(.fileName) > 0 Then
            frm.MousePointer = vbHourglass
            Dim bShowGrid As Boolean
            Dim pic As IPictureDisp
            bShowGrid = frm.AddFlow1.ShowGrid
            frm.AddFlow1.ShowGrid = False
            Set pic = frm.AddFlow1.ExportPicture(afAllItems, True, True)
            frm.AddFlow1.ShowGrid = bShowGrid
            On Error GoTo ControlError   ' Activa la rutina de control de errores.
            SavePicture pic, .fileName
            On Error GoTo 0   ' Desactiva la deteccin de errores.
            frm.MousePointer = vbDefault
        End If
    End With
Exit Sub   ' Salir para evitar el controlador.
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case cdlCancel   'se Cancelo la orden
            mainFrm.dlgCommonDialog.fileName = vbNullString
        Case 70, 75
            '70: Se ha denegado el permiso
            MsgBox " FileSaveAsEMF, Error #" & Str$(Err.Number) & ": " & Err.Description
            Logout " FileSaveAsEMF, Error #" & Str$(Err.Number) & ": " & Err.Description
        Case Else
            Logout " FileSaveAsEMF, Error #" & Str$(Err.Number) & ": " & Err.Description
            Error Err.Number
    End Select
    Resume Next  ' Continuar ejecucin en la lnea siguiente a la que caus el error.
End Sub

Public Sub FileSaveAsHTML(frm As frmDoc)
Dim bShowGrid As Boolean
Dim ha_cambiado As Boolean
Dim pic1 As IPictureDisp
Dim s As String
Dim pfile As Integer
Dim titulo As String
Dim rutaWMF As String

    With mainFrm.dlgCommonDialog
        .DefaultExt = FILE_HTML_EXT
        .Filter = FILE_HTML_FLT
        If LenB(pathOUT) = 0 Then
            .fileName = FileSinExtension(frm.sFullDocname)
        Else
            .fileName = pathOUT & "\" & FileSinRutaNiExtension(frm.sFullDocname)
        End If
        If LenB(.fileName) > 0 Then .fileName = .fileName & "." & LCase$(FILE_HTML_EXT)
        .DialogTitle = "Save As HTML File..."
        .Flags = cdlOFNOverwritePrompt Or cdlOFNCreatePrompt Or cdlOFNHideReadOnly
        .CancelError = True
        If Not (soloHTML Or soloHTML_FLAT) Then
            On Error GoTo ControlError   ' Activa la rutina de control de errores.
            .ShowSave
            On Error GoTo 0   ' Desactiva la deteccin de errores.
        End If
        titulo = FileSinRutaNiExtension(.fileName)
        rutaWMF = FileSinExtension(.fileName) & ".wmf"
        
        If LenB(.fileName) > 0 Then
            frm.MousePointer = vbHourglass
            bShowGrid = frm.AddFlow1.ShowGrid
            ha_cambiado = frm.AddFlow1.IsChanged
            
            frm.AddFlow1.ShowGrid = False
            s = "<HTML>" & vbNewLine
            s = s & "<HEAD>" & vbNewLine
            s = s & "<META HTTP-EQUIV=""Content-Type"" CONTENT=""text/html; charset=windows-1252"">" & vbNewLine
            s = s & "<META NAME=""Generator"" CONTENT=""FSM Editor Diagram"">" & vbNewLine
            s = s & "<TITLE>" & titulo & "</TITLE>" & vbNewLine
            s = s & "</HEAD>" & vbNewLine
            s = s & "<BODY>" & vbNewLine
            s = s & "<FONT SIZE=2><P ALIGN=""LEFT""><IMG SRC=""" & FileSinRuta(rutaWMF) & """></P>" & vbNewLine
            s = s & "<p><U><B>FSM function name:</B></U><BR>" & TextoHTML(DimeDatoFSM(FSM_NAME, frm.AddFlow1), 4) & "</p>" & vbNewLine
            s = s & "<p><U><B>Parameters:</B></U><BR>" & vbNewLine & TextoHTML(DimeDatoFSM(FSM_PARAMETER, frm.AddFlow1), 4) & "</p>" & vbNewLine
            s = s & "<p><U><B>Return type:</B></U><BR>" & vbNewLine & TextoHTML(DimeDatoFSM(FSM_RETURN_TYPE, frm.AddFlow1), 4) & "</p>" & vbNewLine
            s = s & "<p><U><B>Module header:</B></U><BR>" & vbNewLine & TextoHTML(DimeDatoFSM(FSM_MOD_HEADER, frm.AddFlow1), 4) & "</p>" & vbNewLine
            s = s & "<p><U><B>Global initialization:</B></U><BR>" & vbNewLine & TextoHTML(DimeDatoFSM(FSM_GLOBAL_INIT, frm.AddFlow1), 4) & "</p>" & vbNewLine
            s = s & "<p><U><B>Function header:</B></U><BR>" & vbNewLine & TextoHTML(DimeDatoFSM(FSM_FUN_HEADER, frm.AddFlow1), 4) & "</p>" & vbNewLine
            s = s & "<p><U><B>Global actions (before FSM analysis):</B></U><BR>" & vbNewLine & TextoHTML(DimeDatoFSM(FSM_GLOBAL_PRE_ACCION, frm.AddFlow1), 4) & "</p>" & vbNewLine
            s = s & "<p><U><B>Global actions (after FSM analysis):</B></U><BR>" & vbNewLine & TextoHTML(DimeDatoFSM(FSM_GLOBAL_POS_ACCION, frm.AddFlow1), 4) & "</p>" & vbNewLine
            s = s & "<p><U><B>Global final (out of FSM function):</B></U><BR>" & vbNewLine & TextoHTML(DimeDatoFSM(FSM_GLOBAL_END, frm.AddFlow1), 4) & "</p>" & vbNewLine
            s = s & "<p><U><B>Links:</B></U>&nbsp;&nbsp;&nbsp;&nbsp;" & LinksHTML(frm, soloHTML_FLAT) & "</FONT></p>" & vbNewLine
            s = s & "</BODY>" & vbNewLine
            s = s & "</HTML>"
            On Error GoTo ControlError   ' Activa la rutina de control de errores.
            'Salva metafile
            AddDummyNode frm.AddFlow1
            Set pic1 = frm.AddFlow1.ExportPicture(afAllItems, True, True)
            RemoveDummyNode frm.AddFlow1
            SavePicture pic1, rutaWMF

            frm.AddFlow1.ShowGrid = bShowGrid
            frm.AddFlow1.SetChangedFlag ha_cambiado

            'salva HTML
            pfile = FreeFile
            Open .fileName For Output As #pfile
            Print #pfile, s
            Close pfile
            On Error GoTo 0   ' Desactiva la deteccin de errores.
            frm.MousePointer = vbDefault
        End If
    End With
Exit Sub   ' Salir para evitar el controlador.
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case cdlCancel   'se Cancelo la orden
            mainFrm.dlgCommonDialog.fileName = vbNullString
        Case 70, 75
            '70: Se ha denegado el permiso
            MsgBox " FileSaveAsHTML, Error #" & Str$(Err.Number) & ": " & Err.Description
            Logout " FileSaveAsHTML, Error #" & Str$(Err.Number) & ": " & Err.Description
        Case Else
            Logout " FileSaveAsHTML, Error #" & Str$(Err.Number) & ": " & Err.Description
            Error Err.Number
    End Select
    Resume Next  ' Continuar ejecucin en la lnea siguiente a la que caus el error.
End Sub

Public Sub GenerarListado(frm As frmDoc)
    
    With mainFrm.dlgCommonDialog
        .DefaultExt = FILE_LST_EXT
        .Filter = FILE_LST_FLT
        If LenB(pathOUT) = 0 Then
            .fileName = FileSinExtension(frm.sFullDocname)
        Else
            .fileName = pathOUT & "\" & FileSinRutaNiExtension(frm.sFullDocname)
        End If
        If LenB(.fileName) > 0 Then .fileName = .fileName & "." & LCase$(FILE_LST_EXT)
        .DialogTitle = "Save As List file..."
        .Flags = cdlOFNOverwritePrompt Or cdlOFNCreatePrompt Or cdlOFNHideReadOnly
        .CancelError = True
        If Not soloList Then
            On Error GoTo ControlError   ' Activa la rutina de control de errores.
            .ShowSave
            On Error GoTo 0   ' Desactiva la deteccin de errores.
        End If


        If LenB(.fileName) > 0 Then
            frm.MousePointer = vbHourglass
            Dim pfile As Integer
            
            pfile = FreeFile
            Open .fileName For Output As pfile
            Print #pfile, Listado(frm.AddFlow1)
            frm.MousePointer = vbDefault
            Close pfile
        End If
    End With
Exit Sub   ' Salir para evitar el controlador.
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case cdlCancel   'se Cancelo la orden
            mainFrm.dlgCommonDialog.fileName = vbNullString
        Case Else
            Logout " GenerarListado, Error #" & Str$(Err.Number) & ": " & Err.Description
            Error Err.Number
    End Select
    Resume Next  ' Continuar ejecucin en la lnea siguiente a la que caus el error.
End Sub

Public Sub SalvarC_Code(frm As frmDoc, code As String)
Dim pfile As Integer
Dim puedeSalvar As Boolean
Dim campo(0 To 1) As String '0=Code 1=Header
Dim fileHeader As String
Dim modoInteractivo As Boolean
    
    
    modoInteractivo = Not (soloC Or soloC_SwCase Or soloC_DirectP Or soloC_PArray Or soloC_HSwCase Or soloC_HSwCaseReentrant)
    If LenB(code) = 0 Then
        LogError "Code can't be created:[" & FileSinRuta(frm.sFullDocname) & "]"
        Exit Sub
    End If
    
    ExtraeTodosCampos campo(), code
    
    With mainFrm.dlgCommonDialog
        .DefaultExt = FILE_C_EXT
        .Filter = FILE_C_FLT
        If LenB(pathOUT) = 0 Then
            .fileName = FileSinExtension(frm.sFullDocname)
        Else
            .fileName = pathOUT & "\" & FileSinRutaNiExtension(frm.sFullDocname)
        End If
        If LenB(.fileName) > 0 Then .fileName = .fileName & "." & LCase$(FILE_C_EXT)
        .DialogTitle = "Save Finite_State file as Ansi-C File..."
        .Flags = cdlOFNOverwritePrompt Or cdlOFNCreatePrompt Or cdlOFNHideReadOnly
        .CancelError = True
        If modoInteractivo Then
            On Error GoTo ControlError   ' Activa la rutina de control de errores.
            .ShowSave
            On Error GoTo 0   ' Desactiva la deteccin de errores.
        End If
        If LenB(.fileName) > 0 Then
            frm.MousePointer = vbHourglass
            
            'Salva si es permitido
            puedeSalvar = True
            If FileExist(.fileName, vbHidden Or vbSystem Or vbReadOnly) Then
                If GetAttr(.fileName) And (vbHidden Or vbSystem Or vbReadOnly) Then
                    If modoInteractivo Then
                        MsgBox "I can't save the changes in:" & vbNewLine & .fileName, _
                               vbExclamation, "Attention!"
                    End If
                    puedeSalvar = False
                End If
            End If
            If puedeSalvar Then
                ' Save the c_file
                pfile = FreeFile
                Open .fileName For Output As pfile
                Print #pfile, campo(0); 'C code
                Close pfile
                
                ' Save the h_file
                fileHeader = FileSinExtension(.fileName) & "." & LCase$(FILE_H_EXT)
                'Elimina el header previo
                If FileExist(fileHeader, vbHidden Or vbSystem Or vbReadOnly) Then
                    SetAttr fileHeader, vbArchive
                    Kill fileHeader
                End If
                pfile = FreeFile
                Open fileHeader For Output As pfile
                Print #pfile, campo(1); 'H code
                Close pfile
            Else
                LogError "Fsm can't save, access denied to file:[" & .fileName & "]"
            End If
            
            frm.MousePointer = vbDefault
'            On Error GoTo 0   ' Desactiva la deteccin de errores.
        End If
    End With
Exit Sub   ' Salir para evitar el controlador.
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case cdlCancel   'se Cancelo la orden
            mainFrm.dlgCommonDialog.fileName = vbNullString
'        Case 58, 75, 61704
'            '58: El fichero ya existe
'            '75: Error de acceso a la ruta o el archivo
'            '61704: No permite salvar si el fichero es de solo lectura
'            MsgBox " SalvarC_Code, Error #" & Str$(Err.Number) & ": " & Err.Description
'            Logout " SalvarC_Code, Error #" & Str$(Err.Number) & ": " & Err.Description
        Case Else
            #If DEBUG_ExtendLogOut Then
                Logout " SalvarC_Code, Error #" & Str$(Err.Number) & ": " & Err.Description
            #End If
            LogError "Fsm can't save [unexpected error]"
            Error Err.Number
    End Select
    Resume Next  ' Continuar ejecucin en la lnea siguiente a la que caus el error.
End Sub
Public Sub ViewStatusBar()
Dim i As Long
    mainFrm.mnuViewStatusBar.Checked = Not mainFrm.mnuViewStatusBar.Checked
    mainFrm.sbStatusBar.Visible = mainFrm.mnuViewStatusBar.Checked
    For i = 0 To Forms.count - 1
        If Forms(i).Tag = FILE_FSM_EXT Then 'Comprueba Marca de Form vlido
            Forms(i).mnuViewStatusBar.Checked = mainFrm.mnuViewStatusBar.Checked
        Else
            If Forms(i).Tag <> READY_TO_RECEIVE Then   'Comprueba Marca de Form vlido
                Logout " ViewStatusBar, Forms(i).Tag <> FILE_FSM_EXT? "
            End If
        End If
    Next
End Sub

Public Sub ViewToolbar()
Dim i As Long
    mainFrm.mnuViewToolbar.Checked = Not mainFrm.mnuViewToolbar.Checked
    mainFrm.tbToolBar.Visible = mainFrm.mnuViewToolbar.Checked
    For i = 0 To Forms.count - 1
        If Forms(i).Tag = FILE_FSM_EXT Then 'Comprueba Marca de Form vlido
            Forms(i).mnuViewToolbar.Checked = mainFrm.mnuViewToolbar.Checked
        Else
            If Forms(i).Tag <> READY_TO_RECEIVE Then   'Comprueba Marca de Form vlido
                Logout " ViewToolbar, Forms(i).Tag <> FILE_FSM_EXT? "
            End If
        End If
    Next
End Sub

Public Sub HelpAbout(index As Integer)
    If index = 0 Then
'        frmAyuda.Show vbModal
        mainFrm.dlgCommonDialog.HelpFile = App.HelpFile
        mainFrm.dlgCommonDialog.HelpCommand = cdlHelpContents
        mainFrm.dlgCommonDialog.ShowHelp
    Else
        frmLib_LinkInstance.Stopped
        frmAbout.Show vbModal
        frmLib_LinkInstance.Running
    End If

    
End Sub

Private Sub WriteRecentFiles(OpenFileName As String, sMRU() As String)
    'Organiza lista de ultimos ficheros (existentes) + actual
    sMRU(1) = OpenFileName
    UpdateRecentFiles sMRU(), 1
End Sub
Private Sub UpdateRecentFiles(sMRU() As String, Optional j As Integer = 0)
Dim i As Integer
Dim k As Integer
Dim strFile As String
Dim key As String
    
    'Organiza lista de ultimos ficheros (existentes)
    For i = 1 To MRU_SIZE
        key = MRU_KEY & i
        strFile = GetSetting(App.Title, MRU_SECTION, key)
        If FileExist(strFile, vbNormal + vbReadOnly) And j < MRU_SIZE Then
            For k = 1 To j
                If LCase$(sMRU(k)) = LCase$(strFile) Then Exit For
            Next
            If k > j Then
                j = j + 1
                sMRU(j) = strFile
            End If
        End If
    Next

    'Salva lista de ultimos ficheros
    For i = 1 To MRU_SIZE
        key = MRU_KEY & i
        SaveSetting App.Title, MRU_SECTION, key, sMRU(i)
    Next
End Sub

Public Sub GetRecentFiles()
Dim i As Integer, j As Integer
Dim iMax As Integer
Dim varFiles As Variant ' Variable to store the returned array
    
    ' Get MRU list from the registry
    If GetSetting(App.Title, MRU_SECTION, MRU_KEY & "1") <> Empty Then
        varFiles = GetAllSettings(App.Title, MRU_SECTION)
        
        iMax = UBound(varFiles, 1)
        If iMax > MRU_SIZE Then iMax = MRU_SIZE
        For i = 0 To iMax
            If FileExist(CStr(varFiles(i, 1)), vbNormal + vbReadOnly) Then
                For j = 0 To Forms.count - 1
                    If Forms(j).Tag = FILE_FSM_EXT Then 'Comprueba Marca de Form vlido
                        Forms(j).mnuFileMRU(i).Caption = varFiles(i, 1)
                        If LenB(varFiles(i, 1)) > 0 Then
                            Forms(j).mnuFileMRU(i).Visible = True
                        Else
                            Forms(j).mnuFileMRU(i).Visible = False
                        End If
                    Else
                        If Forms(j).Tag <> READY_TO_RECEIVE Then   'Comprueba Marca de Form vlido
                            Logout " GetRecentFiles, Forms(j).Tag <> FILE_FSM_EXT? "
                        End If
                    End If
                Next j
            End If
        Next i
    End If
End Sub

Private Sub UpdateFileMenu(fileName As String)
Dim sMRU(1 To MRU_SIZE) As String

    ' Check if the name of the files is already in the MRU list
    If Not OnRecentFilesList(fileName) Then
        WriteRecentFiles fileName, sMRU()
    Else
        UpdateRecentFiles sMRU()
    End If
    
    GetRecentFiles  ' Update MRU
End Sub

Public Sub FileMRU(index As Integer)
    FileOpen mainFrm.mnuFileMRU(index).Caption
    GetRecentFiles  ' Update MRU
End Sub

Private Function OnRecentFilesList(fileName As String) As Boolean
Dim i As Integer

    For i = 0 To MRU_SIZE - 1
        If LCase$(mainFrm.mnuFileMRU(i).Caption) = LCase$(fileName) Then
            OnRecentFilesList = True
            Exit Function
        End If
    Next
    OnRecentFilesList = False
End Function

Private Sub SalvaDiagrama(frm As frmDoc)
Dim nombreFichero As String
Dim nombreFicheroBak As String
Dim permiteSalvar As Boolean

    nombreFichero = frm.sFullDocname
    nombreFicheroBak = nombreFichero & ".bak"
    
    #If DEBUG_ExtendLogOut Then
        Logout " SalvaDiagrama: [" & nombreFichero & "]"
        Logout " SalvaDiagrama: TomaGrafoInfo frm.AddFlow1"
    #End If
    'Codifica la informacion del grafo
    TomaGrafoInfo frm
    
    'Comprueba si se puede salvar
    permiteSalvar = True
    If FileExist(nombreFichero, vbReadOnly Or vbHidden Or vbSystem) Then
        If GetAttr(nombreFichero) And (vbHidden Or vbSystem Or vbReadOnly) Then
            MsgBox "I can't save the changes in:" & vbNewLine & nombreFichero, vbExclamation, "Attention!"
            permiteSalvar = False
        Else
            EliminaFile (nombreFicheroBak)
            Name nombreFichero As nombreFicheroBak
        End If
    End If
    
    'Salva creando un BackUp
    If permiteSalvar Then
        ' Save the file
        #If DEBUG_ExtendLogOut Then
            Logout " SalvaDiagrama: frm.AddFlow1.SaveFile " & nombreFichero
        #End If
        On Error GoTo ControlError   ' Activa la rutina de control de errores.
        frm.AddFlow1.SaveFile nombreFichero
        On Error GoTo 0   ' Desactiva la deteccin de errores.
        #If DEBUG_ExtendLogOut Then
            Logout " SalvaDiagrama: frm.AddFlow1.SaveFile " & nombreFichero & " [SALVADO]"
        #End If
        
        'Elimina el nodo oculto si existe y rellena campos de texto ...
        CargaTextoNodos frm.AddFlow1
        DameGrafoInfo frm.AddFlow1, False
        
        frm.undRed.ClearGraphChanges
        frm.nuevoFSM = False
        frm.bPudoSalvar = True
        frm.undRed.Init frm
    Else
        'Elimina el nodo oculto si existe y rellena campos de texto ...
        CargaTextoNodos frm.AddFlow1
        DameGrafoInfo frm.AddFlow1, False
    End If
        
    UpdateFileMenu nombreFichero
    
Exit Sub   ' Salir para evitar el controlador.
Dim iReintentos As Long
ControlError:   ' Rutina de control de errores.
    Select Case Err.Number   ' Evala el nmero de error.
        Case &H80010108     'Error de automatizacin
            iReintentos = iReintentos + 1
            If iReintentos < 10 Then
                Logout " SalvaDiagrama: frm.AddFlow1.SaveFile " & nombreFichero & " reintento" & Str$(iReintentos)
'                DoEvents
                Resume
            Else
                Logout " SalvaDiagrama, Error #" & Str$(Err.Number) & ": " & Err.Description
                Error Err.Number
            End If
        Case Else
            Logout " SalvaDiagrama, Error #" & Str$(Err.Number) & ": " & Err.Description
            Error Err.Number
    End Select
    Resume Next  ' Continuar ejecucin en la lnea siguiente a la que caus el error.
End Sub

