VERSION 5.00
Begin VB.Form frmLib_LinkInstance 
   Caption         =   "frmLinkInstance"
   ClientHeight    =   1050
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2010
   LinkTopic       =   "Form1"
   ScaleHeight     =   1050
   ScaleWidth      =   2010
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrRetry 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   120
      Top             =   480
   End
   Begin VB.CommandButton cmdPrevInstance 
      Caption         =   "PrevInstance"
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1575
   End
End
Attribute VB_Name = "frmLib_LinkInstance"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private disableOpenFile As Long
Private stoppedInstances() As String
Private numStoppedInstances As Long

Private Sub cmdPrevInstance_Click()
'    MsgBox cmdPrevInstance.Caption
    If IsThisAValidFile(cmdPrevInstance.Caption) Then
        Pile cmdPrevInstance.Caption
    End If
    cmdPrevInstance.Caption = READY_TO_RECEIVE
End Sub

Private Sub Form_Load()
    #If DEBUG_ExtendLogOut Then
        Logout "frmLib_LinkInstance.Form_Load"
    #End If
    disableOpenFile = 0
    Caption = READY_TO_RECEIVE
    cmdPrevInstance.Caption = READY_TO_RECEIVE
    Me.Visible = False
    Me.Tag = READY_TO_RECEIVE
End Sub

Private Sub OpenThisFile(sFile As String)
    FileOpen sFile
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Como poner una ventana en primer plano y la madre que la pari: Resumen
    ' Apis y funciones probadas que parecen no funcionar
    '   BringWindowToTop Me.hwnd
    '   Me.ZOrder 0
    '   Me.Show
    '   Me.WindowState = vbMaximized
    '   Me.SetFocus
    '   SetForegroundWindow Me.hwnd
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    '   Lo que funciona:
    ' En modo edicion solo parece necesario emplear esta api:
    '   ShowWindow Me.hwnd, SW_SHOWNORMAL
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Pero el compilado no funciona, he comprobado que aadiendo esta otra:
    '   SetWindowPos Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, _
    '                SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
    ' El problema es que ahora se queda siempre en primer plano, la solucion:
    '   SetWindowPos Me.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0,
    '                SWP_SHOWWINDOW Or SWP_NOMOVE Or SWP_NOSIZE
    '
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ShowWindow mainFrm.hwnd, SW_SHOWNORMAL
    SetWindowPos mainFrm.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_SHOWWIN_NOMOV_NOSIZ
    SetWindowPos mainFrm.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_SHOWWIN_NOMOV_NOSIZ
End Sub


Private Sub tmrRetry_Timer()
    If disableOpenFile = 0 Then
        If numStoppedInstances Then
            OpenThisFile stoppedInstances(numStoppedInstances)
            stoppedInstances(numStoppedInstances) = vbNullString
            numStoppedInstances = numStoppedInstances - 1
        End If
        tmrRetry.enabled = (numStoppedInstances > 0)
    End If
End Sub

Private Sub Pile(sFile As String)
    numStoppedInstances = numStoppedInstances + 1
    ReDim Preserve stoppedInstances(1 To numStoppedInstances) As String
    stoppedInstances(numStoppedInstances) = sFile
    tmrRetry = True
End Sub

Public Sub Stopped()
    disableOpenFile = disableOpenFile + 1
    tmrRetry.enabled = True
End Sub
Public Sub Running()
    disableOpenFile = disableOpenFile - 1
End Sub




